# **********************************************************************
#
# Copyright (c) 2003-2005 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************

# Ice version 3.0.0
# Generated from file `Observer.ice'

import Ice, IcePy, __builtin__
import Glacier2_Session_ice
import IceGrid_Exception_ice
import IceGrid_Descriptor_ice
import IceGrid_Admin_ice

# Included module Glacier2
_M_Glacier2 = Ice.openModule('Glacier2')

# Included module Ice
_M_Ice = Ice.openModule('Ice')

# Included module IceGrid
_M_IceGrid = Ice.openModule('IceGrid')

# Start of module IceGrid
__name__ = 'IceGrid'

_M_IceGrid.ServerDynamicInfo = Ice.createTempClass()
class ServerDynamicInfo(object):
    def __init__(self, id='', state=_M_IceGrid.ServerState.Inactive, pid=0, enabled=False):
        self.id = id
        self.state = state
        self.pid = pid
        self.enabled = enabled

    def __hash__(self):
        _h = 0
        _h = 5 * _h + __builtin__.hash(self.id)
        _h = 5 * _h + __builtin__.hash(self.state)
        _h = 5 * _h + __builtin__.hash(self.pid)
        _h = 5 * _h + __builtin__.hash(self.enabled)
        return _h % 0x7fffffff

    def __eq__(self, other):
        if not self.id == other.id:
            return False
        if not self.state == other.state:
            return False
        if not self.pid == other.pid:
            return False
        if not self.enabled == other.enabled:
            return False
        return True

    def __str__(self):
        return IcePy.stringify(self, _M_IceGrid._t_ServerDynamicInfo)

    __repr__ = __str__

_M_IceGrid._t_ServerDynamicInfo = IcePy.defineStruct('::IceGrid::ServerDynamicInfo', ServerDynamicInfo, (
    ("id", IcePy._t_string),
    ("state", _M_IceGrid._t_ServerState),
    ("pid", IcePy._t_int),
    ("enabled", IcePy._t_bool)
))

_M_IceGrid.ServerDynamicInfo = ServerDynamicInfo
del ServerDynamicInfo

_M_IceGrid._t_ServerDynamicInfoSeq = IcePy.defineSequence('::IceGrid::ServerDynamicInfoSeq', _M_IceGrid._t_ServerDynamicInfo)

_M_IceGrid.AdapterDynamicInfo = Ice.createTempClass()
class AdapterDynamicInfo(object):
    def __init__(self, id='', proxy=None):
        self.id = id
        self.proxy = proxy

    def __hash__(self):
        _h = 0
        _h = 5 * _h + __builtin__.hash(self.id)
        _h = 5 * _h + __builtin__.hash(self.proxy)
        return _h % 0x7fffffff

    def __eq__(self, other):
        if not self.id == other.id:
            return False
        if not self.proxy == other.proxy:
            return False
        return True

    def __str__(self):
        return IcePy.stringify(self, _M_IceGrid._t_AdapterDynamicInfo)

    __repr__ = __str__

_M_IceGrid._t_AdapterDynamicInfo = IcePy.defineStruct('::IceGrid::AdapterDynamicInfo', AdapterDynamicInfo, (
    ("id", IcePy._t_string),
    ("proxy", IcePy._t_ObjectPrx)
))

_M_IceGrid.AdapterDynamicInfo = AdapterDynamicInfo
del AdapterDynamicInfo

_M_IceGrid._t_AdapterDynamicInfoSeq = IcePy.defineSequence('::IceGrid::AdapterDynamicInfoSeq', _M_IceGrid._t_AdapterDynamicInfo)

_M_IceGrid.NodeDynamicInfo = Ice.createTempClass()
class NodeDynamicInfo(object):
    def __init__(self, name='', info=_M_IceGrid.NodeInfo(), servers=None, adapters=None):
        self.name = name
        self.info = info
        self.servers = servers
        self.adapters = adapters

    def __hash__(self):
        _h = 0
        _h = 5 * _h + __builtin__.hash(self.name)
        _h = 5 * _h + __builtin__.hash(self.info)
        if self.servers:
            for _i0 in self.servers:
                _h = 5 * _h + __builtin__.hash(_i0)
        if self.adapters:
            for _i1 in self.adapters:
                _h = 5 * _h + __builtin__.hash(_i1)
        return _h % 0x7fffffff

    def __eq__(self, other):
        if not self.name == other.name:
            return False
        if not self.info == other.info:
            return False
        if not self.servers == other.servers:
            return False
        if not self.adapters == other.adapters:
            return False
        return True

    def __str__(self):
        return IcePy.stringify(self, _M_IceGrid._t_NodeDynamicInfo)

    __repr__ = __str__

_M_IceGrid._t_NodeDynamicInfo = IcePy.defineStruct('::IceGrid::NodeDynamicInfo', NodeDynamicInfo, (
    ("name", IcePy._t_string),
    ("info", _M_IceGrid._t_NodeInfo),
    ("servers", _M_IceGrid._t_ServerDynamicInfoSeq),
    ("adapters", _M_IceGrid._t_AdapterDynamicInfoSeq)
))

_M_IceGrid.NodeDynamicInfo = NodeDynamicInfo
del NodeDynamicInfo

_M_IceGrid._t_NodeDynamicInfoSeq = IcePy.defineSequence('::IceGrid::NodeDynamicInfoSeq', _M_IceGrid._t_NodeDynamicInfo)

_M_IceGrid.NodeObserver = Ice.createTempClass()
class NodeObserver(Ice.Object):
    def __init__(self):
        if __builtin__.type(self) == _M_IceGrid.NodeObserver:
            raise RuntimeError('IceGrid.NodeObserver is an abstract class')

    def ice_ids(self, current=None):
        return ('::Ice::Object', '::IceGrid::NodeObserver')

    def ice_id(self, current=None):
        return '::IceGrid::NodeObserver'

    #
    # Operation signatures.
    #
    # def init(self, nodes, current=None):
    # def nodeUp(self, node, current=None):
    # def nodeDown(self, name, current=None):
    # def updateServer(self, node, updatedInfo, current=None):
    # def updateAdapter(self, node, updatedInfo, current=None):

    def __str__(self):
        return IcePy.stringify(self, _M_IceGrid._t_NodeObserver)

    __repr__ = __str__

_M_IceGrid.NodeObserverPrx = Ice.createTempClass()
class NodeObserverPrx(Ice.ObjectPrx):

    def init(self, nodes, _ctx=None):
        return _M_IceGrid.NodeObserver._op_init.invoke(self, (nodes, ), _ctx)

    def init_async(self, _cb, nodes, _ctx=None):
        return _M_IceGrid.NodeObserver._op_init.invokeAsync(self, _cb, (nodes, ), _ctx)

    def nodeUp(self, node, _ctx=None):
        return _M_IceGrid.NodeObserver._op_nodeUp.invoke(self, (node, ), _ctx)

    def nodeDown(self, name, _ctx=None):
        return _M_IceGrid.NodeObserver._op_nodeDown.invoke(self, (name, ), _ctx)

    def updateServer(self, node, updatedInfo, _ctx=None):
        return _M_IceGrid.NodeObserver._op_updateServer.invoke(self, (node, updatedInfo), _ctx)

    def updateAdapter(self, node, updatedInfo, _ctx=None):
        return _M_IceGrid.NodeObserver._op_updateAdapter.invoke(self, (node, updatedInfo), _ctx)

    def checkedCast(proxy, facetOrCtx=None, _ctx=None):
        return _M_IceGrid.NodeObserverPrx.ice_checkedCast(proxy, '::IceGrid::NodeObserver', facetOrCtx, _ctx)
    checkedCast = staticmethod(checkedCast)

    def uncheckedCast(proxy, facet=''):
        return _M_IceGrid.NodeObserverPrx.ice_uncheckedCast(proxy, facet)
    uncheckedCast = staticmethod(uncheckedCast)

_M_IceGrid._t_NodeObserverPrx = IcePy.defineProxy('::IceGrid::NodeObserver', NodeObserverPrx)

_M_IceGrid._t_NodeObserver = IcePy.defineClass('::IceGrid::NodeObserver', NodeObserver, True, None, (), ())
NodeObserver.ice_type = _M_IceGrid._t_NodeObserver

NodeObserver._op_init = IcePy.Operation('init', Ice.OperationMode.Normal, False, (_M_IceGrid._t_NodeDynamicInfoSeq,), (), None, ())
NodeObserver._op_nodeUp = IcePy.Operation('nodeUp', Ice.OperationMode.Normal, False, (_M_IceGrid._t_NodeDynamicInfo,), (), None, ())
NodeObserver._op_nodeDown = IcePy.Operation('nodeDown', Ice.OperationMode.Normal, False, (IcePy._t_string,), (), None, ())
NodeObserver._op_updateServer = IcePy.Operation('updateServer', Ice.OperationMode.Normal, False, (IcePy._t_string, _M_IceGrid._t_ServerDynamicInfo), (), None, ())
NodeObserver._op_updateAdapter = IcePy.Operation('updateAdapter', Ice.OperationMode.Normal, False, (IcePy._t_string, _M_IceGrid._t_AdapterDynamicInfo), (), None, ())

_M_IceGrid.NodeObserver = NodeObserver
del NodeObserver

_M_IceGrid.NodeObserverPrx = NodeObserverPrx
del NodeObserverPrx

_M_IceGrid.RegistryObserver = Ice.createTempClass()
class RegistryObserver(Ice.Object):
    def __init__(self):
        if __builtin__.type(self) == _M_IceGrid.RegistryObserver:
            raise RuntimeError('IceGrid.RegistryObserver is an abstract class')

    def ice_ids(self, current=None):
        return ('::Ice::Object', '::IceGrid::RegistryObserver')

    def ice_id(self, current=None):
        return '::IceGrid::RegistryObserver'

    #
    # Operation signatures.
    #
    # def init(self, serial, applications, current=None):
    # def applicationAdded(self, serial, desc, current=None):
    # def applicationRemoved(self, serial, name, current=None):
    # def applicationUpdated(self, serial, desc, current=None):

    def __str__(self):
        return IcePy.stringify(self, _M_IceGrid._t_RegistryObserver)

    __repr__ = __str__

_M_IceGrid.RegistryObserverPrx = Ice.createTempClass()
class RegistryObserverPrx(Ice.ObjectPrx):

    def init(self, serial, applications, _ctx=None):
        return _M_IceGrid.RegistryObserver._op_init.invoke(self, (serial, applications), _ctx)

    def init_async(self, _cb, serial, applications, _ctx=None):
        return _M_IceGrid.RegistryObserver._op_init.invokeAsync(self, _cb, (serial, applications), _ctx)

    def applicationAdded(self, serial, desc, _ctx=None):
        return _M_IceGrid.RegistryObserver._op_applicationAdded.invoke(self, (serial, desc), _ctx)

    def applicationRemoved(self, serial, name, _ctx=None):
        return _M_IceGrid.RegistryObserver._op_applicationRemoved.invoke(self, (serial, name), _ctx)

    def applicationUpdated(self, serial, desc, _ctx=None):
        return _M_IceGrid.RegistryObserver._op_applicationUpdated.invoke(self, (serial, desc), _ctx)

    def checkedCast(proxy, facetOrCtx=None, _ctx=None):
        return _M_IceGrid.RegistryObserverPrx.ice_checkedCast(proxy, '::IceGrid::RegistryObserver', facetOrCtx, _ctx)
    checkedCast = staticmethod(checkedCast)

    def uncheckedCast(proxy, facet=''):
        return _M_IceGrid.RegistryObserverPrx.ice_uncheckedCast(proxy, facet)
    uncheckedCast = staticmethod(uncheckedCast)

_M_IceGrid._t_RegistryObserverPrx = IcePy.defineProxy('::IceGrid::RegistryObserver', RegistryObserverPrx)

_M_IceGrid._t_RegistryObserver = IcePy.defineClass('::IceGrid::RegistryObserver', RegistryObserver, True, None, (), ())
RegistryObserver.ice_type = _M_IceGrid._t_RegistryObserver

RegistryObserver._op_init = IcePy.Operation('init', Ice.OperationMode.Normal, False, (IcePy._t_int, _M_IceGrid._t_ApplicationDescriptorSeq), (), None, ())
RegistryObserver._op_applicationAdded = IcePy.Operation('applicationAdded', Ice.OperationMode.Normal, False, (IcePy._t_int, _M_IceGrid._t_ApplicationDescriptor), (), None, ())
RegistryObserver._op_applicationRemoved = IcePy.Operation('applicationRemoved', Ice.OperationMode.Normal, False, (IcePy._t_int, IcePy._t_string), (), None, ())
RegistryObserver._op_applicationUpdated = IcePy.Operation('applicationUpdated', Ice.OperationMode.Normal, False, (IcePy._t_int, _M_IceGrid._t_ApplicationUpdateDescriptor), (), None, ())

_M_IceGrid.RegistryObserver = RegistryObserver
del RegistryObserver

_M_IceGrid.RegistryObserverPrx = RegistryObserverPrx
del RegistryObserverPrx

_M_IceGrid._t_Query = IcePy.declareClass('::IceGrid::Query')
_M_IceGrid._t_QueryPrx = IcePy.declareProxy('::IceGrid::Query')

_M_IceGrid._t_Admin = IcePy.declareClass('::IceGrid::Admin')
_M_IceGrid._t_AdminPrx = IcePy.declareProxy('::IceGrid::Admin')

_M_IceGrid.Session = Ice.createTempClass()
class Session(_M_Glacier2.Session):
    def __init__(self):
        if __builtin__.type(self) == _M_IceGrid.Session:
            raise RuntimeError('IceGrid.Session is an abstract class')

    def ice_ids(self, current=None):
        return ('::Glacier2::Session', '::Ice::Object', '::IceGrid::Session')

    def ice_id(self, current=None):
        return '::IceGrid::Session'

    #
    # Operation signatures.
    #
    # def keepAlive(self, current=None):
    # def getTimeout(self, current=None):
    # def getQuery(self, current=None):
    # def getAdmin(self, current=None):
    # def setObservers(self, registryObs, nodeObs, current=None):
    # def setObserversByIdentity(self, registryObs, nodeObs, current=None):
    # def startUpdate(self, current=None):
    # def addApplication(self, application, current=None):
    # def syncApplication(self, app, current=None):
    # def updateApplication(self, update, current=None):
    # def removeApplication(self, name, current=None):
    # def finishUpdate(self, current=None):

    def __str__(self):
        return IcePy.stringify(self, _M_IceGrid._t_Session)

    __repr__ = __str__

_M_IceGrid.SessionPrx = Ice.createTempClass()
class SessionPrx(_M_Glacier2.SessionPrx):

    def keepAlive(self, _ctx=None):
        return _M_IceGrid.Session._op_keepAlive.invoke(self, (), _ctx)

    def getTimeout(self, _ctx=None):
        return _M_IceGrid.Session._op_getTimeout.invoke(self, (), _ctx)

    def getQuery(self, _ctx=None):
        return _M_IceGrid.Session._op_getQuery.invoke(self, (), _ctx)

    def getAdmin(self, _ctx=None):
        return _M_IceGrid.Session._op_getAdmin.invoke(self, (), _ctx)

    def setObservers(self, registryObs, nodeObs, _ctx=None):
        return _M_IceGrid.Session._op_setObservers.invoke(self, (registryObs, nodeObs), _ctx)

    def setObserversByIdentity(self, registryObs, nodeObs, _ctx=None):
        return _M_IceGrid.Session._op_setObserversByIdentity.invoke(self, (registryObs, nodeObs), _ctx)

    def startUpdate(self, _ctx=None):
        return _M_IceGrid.Session._op_startUpdate.invoke(self, (), _ctx)

    def addApplication(self, application, _ctx=None):
        return _M_IceGrid.Session._op_addApplication.invoke(self, (application, ), _ctx)

    def syncApplication(self, app, _ctx=None):
        return _M_IceGrid.Session._op_syncApplication.invoke(self, (app, ), _ctx)

    def updateApplication(self, update, _ctx=None):
        return _M_IceGrid.Session._op_updateApplication.invoke(self, (update, ), _ctx)

    def removeApplication(self, name, _ctx=None):
        return _M_IceGrid.Session._op_removeApplication.invoke(self, (name, ), _ctx)

    def finishUpdate(self, _ctx=None):
        return _M_IceGrid.Session._op_finishUpdate.invoke(self, (), _ctx)

    def checkedCast(proxy, facetOrCtx=None, _ctx=None):
        return _M_IceGrid.SessionPrx.ice_checkedCast(proxy, '::IceGrid::Session', facetOrCtx, _ctx)
    checkedCast = staticmethod(checkedCast)

    def uncheckedCast(proxy, facet=''):
        return _M_IceGrid.SessionPrx.ice_uncheckedCast(proxy, facet)
    uncheckedCast = staticmethod(uncheckedCast)

_M_IceGrid._t_SessionPrx = IcePy.defineProxy('::IceGrid::Session', SessionPrx)

_M_IceGrid._t_Session = IcePy.defineClass('::IceGrid::Session', Session, True, None, (_M_Glacier2._t_Session,), ())
Session.ice_type = _M_IceGrid._t_Session

Session._op_keepAlive = IcePy.Operation('keepAlive', Ice.OperationMode.Normal, False, (), (), None, ())
Session._op_getTimeout = IcePy.Operation('getTimeout', Ice.OperationMode.Nonmutating, False, (), (), IcePy._t_int, ())
Session._op_getQuery = IcePy.Operation('getQuery', Ice.OperationMode.Nonmutating, False, (), (), _M_IceGrid._t_QueryPrx, ())
Session._op_getAdmin = IcePy.Operation('getAdmin', Ice.OperationMode.Nonmutating, False, (), (), _M_IceGrid._t_AdminPrx, ())
Session._op_setObservers = IcePy.Operation('setObservers', Ice.OperationMode.Normal, False, (_M_IceGrid._t_RegistryObserverPrx, _M_IceGrid._t_NodeObserverPrx), (), None, ())
Session._op_setObserversByIdentity = IcePy.Operation('setObserversByIdentity', Ice.OperationMode.Normal, False, (_M_Ice._t_Identity, _M_Ice._t_Identity), (), None, ())
Session._op_startUpdate = IcePy.Operation('startUpdate', Ice.OperationMode.Normal, False, (), (), IcePy._t_int, (_M_IceGrid._t_AccessDeniedException,))
Session._op_addApplication = IcePy.Operation('addApplication', Ice.OperationMode.Normal, False, (_M_IceGrid._t_ApplicationDescriptor,), (), None, (_M_IceGrid._t_AccessDeniedException, _M_IceGrid._t_DeploymentException))
Session._op_syncApplication = IcePy.Operation('syncApplication', Ice.OperationMode.Normal, False, (_M_IceGrid._t_ApplicationDescriptor,), (), None, (_M_IceGrid._t_AccessDeniedException, _M_IceGrid._t_DeploymentException, _M_IceGrid._t_ApplicationNotExistException))
Session._op_updateApplication = IcePy.Operation('updateApplication', Ice.OperationMode.Normal, False, (_M_IceGrid._t_ApplicationUpdateDescriptor,), (), None, (_M_IceGrid._t_AccessDeniedException, _M_IceGrid._t_DeploymentException, _M_IceGrid._t_ApplicationNotExistException))
Session._op_removeApplication = IcePy.Operation('removeApplication', Ice.OperationMode.Normal, False, (IcePy._t_string,), (), None, (_M_IceGrid._t_AccessDeniedException, _M_IceGrid._t_ApplicationNotExistException))
Session._op_finishUpdate = IcePy.Operation('finishUpdate', Ice.OperationMode.Normal, False, (), (), None, (_M_IceGrid._t_AccessDeniedException,))

_M_IceGrid.Session = Session
del Session

_M_IceGrid.SessionPrx = SessionPrx
del SessionPrx

_M_IceGrid.SessionManager = Ice.createTempClass()
class SessionManager(_M_Glacier2.SessionManager):
    def __init__(self):
        if __builtin__.type(self) == _M_IceGrid.SessionManager:
            raise RuntimeError('IceGrid.SessionManager is an abstract class')

    def ice_ids(self, current=None):
        return ('::Glacier2::SessionManager', '::Ice::Object', '::IceGrid::SessionManager')

    def ice_id(self, current=None):
        return '::IceGrid::SessionManager'

    #
    # Operation signatures.
    #
    # def createLocalSession(self, userId, current=None):

    def __str__(self):
        return IcePy.stringify(self, _M_IceGrid._t_SessionManager)

    __repr__ = __str__

_M_IceGrid.SessionManagerPrx = Ice.createTempClass()
class SessionManagerPrx(_M_Glacier2.SessionManagerPrx):

    def createLocalSession(self, userId, _ctx=None):
        return _M_IceGrid.SessionManager._op_createLocalSession.invoke(self, (userId, ), _ctx)

    def checkedCast(proxy, facetOrCtx=None, _ctx=None):
        return _M_IceGrid.SessionManagerPrx.ice_checkedCast(proxy, '::IceGrid::SessionManager', facetOrCtx, _ctx)
    checkedCast = staticmethod(checkedCast)

    def uncheckedCast(proxy, facet=''):
        return _M_IceGrid.SessionManagerPrx.ice_uncheckedCast(proxy, facet)
    uncheckedCast = staticmethod(uncheckedCast)

_M_IceGrid._t_SessionManagerPrx = IcePy.defineProxy('::IceGrid::SessionManager', SessionManagerPrx)

_M_IceGrid._t_SessionManager = IcePy.defineClass('::IceGrid::SessionManager', SessionManager, True, None, (_M_Glacier2._t_SessionManager,), ())
SessionManager.ice_type = _M_IceGrid._t_SessionManager

SessionManager._op_createLocalSession = IcePy.Operation('createLocalSession', Ice.OperationMode.Normal, False, (IcePy._t_string,), (), _M_IceGrid._t_SessionPrx, ())

_M_IceGrid.SessionManager = SessionManager
del SessionManager

_M_IceGrid.SessionManagerPrx = SessionManagerPrx
del SessionManagerPrx

# End of module IceGrid

Ice.sliceChecksums["::IceGrid::AdapterDynamicInfo"] = "b371e9a58f115e6ebfbcda735fee57f7"
Ice.sliceChecksums["::IceGrid::AdapterDynamicInfoSeq"] = "54465843167a2f93fa96d13b7f41ea32"
Ice.sliceChecksums["::IceGrid::NodeDynamicInfo"] = "8ebccc05aebaf7f307269d121bceb6a"
Ice.sliceChecksums["::IceGrid::NodeDynamicInfoSeq"] = "f61633c5e3992f718dba78b7f165c2"
Ice.sliceChecksums["::IceGrid::NodeObserver"] = "be913410ec8dddf8b7388c65333c67"
Ice.sliceChecksums["::IceGrid::RegistryObserver"] = "918c7d3fb2242fef5414c404468875"
Ice.sliceChecksums["::IceGrid::ServerDynamicInfo"] = "fd4b9177ca54ae4688b51fa51d6870"
Ice.sliceChecksums["::IceGrid::ServerDynamicInfoSeq"] = "e3fda58997d5cd946e78cae739174cb"
Ice.sliceChecksums["::IceGrid::Session"] = "afb3f9b470eec6a23398c22f190dcf3"
Ice.sliceChecksums["::IceGrid::SessionManager"] = "7920a77eac18bed18ddafd2603fc8d"
